package ejer1;

import java.util.*;

public class GrafoCasillas {
	private int numVertices;
	private ArrayList<NodoCasilla> casillas;
	
	public GrafoCasillas() {
		this.numVertices = 0;
		this.casillas = new ArrayList<NodoCasilla>();
	}
	
	public int getNumVertices() {
		return numVertices;
	}

	public void setNumVertices(int numVertices) {
		this.numVertices = numVertices;
	}	

	public ArrayList<NodoCasilla> getCasillas() {
		return casillas;
	}


	
	//Pre: origen y destino est�n en el grafo 
	public LinkedList<Integer> camino(NodoCasilla origen, NodoCasilla destino){
		HashMap<NodoCasilla,NodoCasilla> visitados = new HashMap<NodoCasilla,NodoCasilla>();
		Queue<NodoCasilla> cola = new LinkedList();
		LinkedList<Integer> lista = new LinkedList<Integer>();
		boolean encontrado = false;
		cola.add(origen);
		visitados.put(origen,null);
		while (!cola.isEmpty() && !encontrado){
			NodoCasilla aux = cola.remove(); //Creamos variable auxiliar para poder ir recorriendo la cola
			encontrado = aux.equals(destino);
			//aux es blanca
			if(aux.info.getEsBlanca()){
				for(NodoCasilla nodo: aux.adyacentes){
					if(!nodo.info.getEsBlanca() && !visitados.containsKey(nodo)){
						cola.add(nodo);
						visitados.put(nodo, aux);
					}
				}
			}
			//aux es negra
			else{
				for(NodoCasilla nodo: aux.adyacentes){
					if(nodo.info.getEsBlanca() && !visitados.containsKey(nodo)){
						cola.add(nodo);
						visitados.put(nodo,aux);
					}
				}
			}

		}

		if (encontrado) {
			NodoCasilla actual = destino;
			while (actual != null){
				lista.addFirst(actual.info.getValor());
				actual = visitados.get(actual);
			}
		}
		return lista;
	}



}
