package ejer2;

import java.util.*;

public class GrafoCiudades {

	private int numVertices; // n? de nodos del grafo
	private LinkedList<NodoCiudad> ciudades;

	public GrafoCiudades() {
		this.numVertices = 0;
		this.ciudades = new LinkedList<NodoCiudad>();
	}

	public ArrayList<CiudadEIntensidad> ciudadesAfectadas(String nomCiudad, float Pintensidad){
		float intensidad = Pintensidad;
		NodoCiudad ciudad= obtenerNodo(nomCiudad);
		Queue<NodoCiudad> cola = new LinkedList<NodoCiudad>();
		HashMap<NodoCiudad, Float> intensidadCiudades = new HashMap<NodoCiudad,Float>();
		ArrayList<CiudadEIntensidad> respuesta = new ArrayList<CiudadEIntensidad>();

		if(intensidad>=1){
			cola.add(ciudad);
			intensidadCiudades.put(ciudad,intensidad);
		}
		while(!cola.isEmpty()){
			NodoCiudad aux = cola.remove();
			intensidad=intensidadCiudades.get(aux);
			for(NodoCiudad adyacente : aux.getAdyacentes()){
				if(!intensidadCiudades.containsKey(adyacente)&&intensidad/2>=1.0){
					cola.add(adyacente);
					intensidadCiudades.put(adyacente,intensidad/2);
				}


			}

		}
		Set<NodoCiudad> ciudades = intensidadCiudades.keySet();
		for(NodoCiudad ciudadKey : ciudades){
			CiudadEIntensidad ciudadEIntensidad = new CiudadEIntensidad(ciudadKey.getNombre(),intensidadCiudades.get(ciudadKey));
			respuesta.add(ciudadEIntensidad);
		}



	return respuesta;
	}

	public NodoCiudad obtenerNodo(String nombre){
		NodoCiudad ciudad = null;
		for(NodoCiudad ciudadActual : ciudades){
			if(ciudadActual.getNombre().equals(nombre)){
				ciudad = ciudadActual;
			}
		}
		return ciudad;
	}

	//AUXILIARES PARA PRUEBAS


	public void anadirArista(NodoCiudad origen, NodoCiudad destino) {

		NodoCiudad c1 = buscar(origen.getNombre());
		if(c1==null) anadirNodo(origen);
		NodoCiudad c2 = buscar(destino.getNombre());
		if(c2==null) anadirNodo(destino);

		origen.getAdyacentes().add(destino);
		destino.getAdyacentes().add(origen);

	}

	//Pre: nodo no est? en el grafo
	private void anadirNodo(NodoCiudad nodo) {
		this.ciudades.add(nodo);
		this.numVertices++;
	}

	private NodoCiudad buscar(String nombre) {
		for(NodoCiudad nodo:ciudades) {
			if(nodo.getNombre().equals(nombre)) return nodo;
		}
		return null;
	}

}
